----------------------------------------------------------------------
--                                                                  --
-- Design unit:   Package of constants for AES cipher module        --
--                                                                  --
-- File name:     aes_pkg.vhd                                       --
--                                                                  --
-- Description:   This package defines common types, subtypes and   --
--                constants required to implement building blocks   --
--                Important constants:                              --
--                   - family type (ALTERA, ACTEL)                  --
--                                                                  --
-- System:        VHDL'93                                           --
--                                                                  --
-- Autors:        Viktor Fischer, LabHC, France                     --
--                                                                  --
--                                                                  --
-- Revision:      Version 2.00, January 2017                        --
--                                                                  --
-- Last changes:  - ...                                             --
--                                                                  --
----------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

PACKAGE aes_pkg IS                                               
--------------------------------------------------------------------------
----   Family versions    ---------------------------------------------
--------------------------------------------------------------------------
  CONSTANT FAMILY_VER : STRING := "ALTERA";  -- Altera FPGA
  --CONSTANT FAMILY_VER : STRING := "ACTEL";   -- Actel FPGA
  
--------------------------------------------------------------------------
-----   Type, sub-type and constant declarations for general use  --------
--------------------------------------------------------------------------
  SUBTYPE SLV_1_0      IS STD_LOGIC_VECTOR(1 DOWNTO 0);
  SUBTYPE SLV_2_0      IS STD_LOGIC_VECTOR(2 DOWNTO 0);
  SUBTYPE SLV_3_0      IS STD_LOGIC_VECTOR(3 DOWNTO 0);
  SUBTYPE SLV_4_0      IS STD_LOGIC_VECTOR(4 DOWNTO 0);
  SUBTYPE SLV_5_0      IS STD_LOGIC_VECTOR(5 DOWNTO 0);
  SUBTYPE SLV_6_0      IS STD_LOGIC_VECTOR(6 DOWNTO 0);
  SUBTYPE SLV_7_0      IS STD_LOGIC_VECTOR(7 DOWNTO 0);
  SUBTYPE SLV_8_0      IS STD_LOGIC_VECTOR(8 DOWNTO 0);
  SUBTYPE SLV_9_0      IS STD_LOGIC_VECTOR(9 DOWNTO 0);
  SUBTYPE SLV_11_0     IS STD_LOGIC_VECTOR(11 DOWNTO 0);
  SUBTYPE SLV_12_0     IS STD_LOGIC_VECTOR(12 DOWNTO 0);
  SUBTYPE SLV_13_0     IS STD_LOGIC_VECTOR(13 DOWNTO 0);
  SUBTYPE SLV_15_0     IS STD_LOGIC_VECTOR(15 DOWNTO 0);
  SUBTYPE SLV_16_0     IS STD_LOGIC_VECTOR(16 DOWNTO 0);
  SUBTYPE SLV_31_0     IS STD_LOGIC_VECTOR(31 DOWNTO 0);
  SUBTYPE SLV_63_0     IS STD_LOGIC_VECTOR(63 DOWNTO 0);
  SUBTYPE SLV_64_0     IS STD_LOGIC_VECTOR(64 DOWNTO 0);
  SUBTYPE SLV_127_0    IS STD_LOGIC_VECTOR(127 DOWNTO 0);
  SUBTYPE SLV_4_2      IS STD_LOGIC_VECTOR(4 DOWNTO 2);
  SUBTYPE SLV_11_1     IS STD_LOGIC_VECTOR(11 DOWNTO 1);
   
END aes_pkg;
-- aes_pkg.vhd