-----------------------------------------------------------------
-- Title: Multiplication by 2 in GF(256) for AES cipher.       --
-- Filename: xtime.vhd                                         --
-----------------------------------------------------------------
-- Ver 1.0                                                     --
-- November 2008                                               --
-----------------------------------------------------------------
-- Author:                                                     --
-- Fischer V.                                                  --
-- (C) 2008 Laboratoire Hubert Curien                          --
-- France                                                      --
-----------------------------------------------------------------
-- Description :                                               --
--                                                             --
-- Simple function implementing multiplication by 2 in         --
-- GF(256) according to the FIPS 197 standard.                 --
--                                                             --
-- Inputs :                                                    --
--    * data_in   : 8-bit data input                           --
--                                                             --
-- Outputs :                                                   --
--    * data_out  : 8-bit data output                          --
-----------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY xtime IS
  PORT (
    data_in       : IN std_logic_vector (7 DOWNTO 0);
    data_out      : OUT std_logic_vector (7 DOWNTO 0)
     );
END xtime;

ARCHITECTURE rtl OF xtime IS
BEGIN

  data_out <= (data_in(6 DOWNTO 0) & '0') XOR "00011011" WHEN (data_in(7)='1')
         ELSE data_in(6 DOWNTO 0) & '0';

END rtl;


